using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ducksound : MonoBehaviour
{
    int objno = 0;
    rtcmixmain RTcmix;
    private bool did_start = false;


    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        // make the path to "ducks.wav" in the Assets directory
        string sfpath = Application.dataPath;
        string rtinputscore = "rtinput(\"" + sfpath + "/ducks.wav\") ";
        RTcmix.SendScore(rtinputscore, objno);

        Debug.Log(rtinputscore); // look in the console to see the constructed path


        string score = "amp = 1 " +
            "ampenv = maketable(\"line\", 1000, 0,0,  3,1,  20,1,  25,0) " +
            "STEREO(0, 0, 25, amp*ampenv, 0, 1) " +
            "MAXBANG(18) ";
        RTcmix.SendScore(score, objno);

        did_start = true;
    }


    // Update is called once per frame
    void Update()
    {
    }


    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 0);

        if(RTcmix.checkbangRTcmix(objno) == 1)
        {
            // we don't need the rtinput(), amp, ampenv -- they're already defined
            string score = "STEREO(0, 0, 25, amp*ampenv, 0, 1) " +
                "MAXBANG(18) ";
            RTcmix.SendScore(score, objno);
        }
    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
